mod Ex08b logic: 'cl'

incl Mtex

incl Mauxb

loc rem 
  \para \bf  8. CVICENIE Z PREDMETU M-INAA-046 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end stvrtok 19.4.2007 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/M-INAA-046-svp/0607ls/?lang=sk 
  \para* \it  Kontakt:  \end mailto:komara@nw.fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom. Zadanie 
  sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  List modification.  \end 

fun/3 Msub 'Tex_f3_ln_msub'
  Msub(x,i,a) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    i < L(x) -> L Msub(x,i,a) = L(x)
  \end
  \eq* 
    i < L(x) -> Sub(Msub(x,i,a),i) = a
  \end
  \eq* 
    i < L(x) & j < L(x) & j != i -> Sub(Msub(x,i,a),j) = Sub(x,j)
  \end

thm Msub_l
  i < L(x) -> L Msub(x,i,a) = L(x)

thm Msub_sub_eq
  i < L(x) -> Sub(Msub(x,i,a),i) = a

thm Msub_sub_ne
  i < L(x) & j < L(x) & j != i -> Sub(Msub(x,i,a),j) = Sub(x,j)

rem 
  \para \bf  Map.  \end 

theory Theory_map

fun F 'Tex_f1_f'

fun Map 'Tex_f1_ln_map_f'
  Map(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    L Map(x) = L(x)
  \end
  \eq* 
    i < L(x) -> Sub(Map(x),i) = F Sub(x,i)
  \end

thm Map_l
  L Map(x) = L(x)

thm Map_sub
  i < L(x) -> Sub(Map(x),i) = F Sub(x,i)

end theory Theory_map

rem 
  \para \bf  Zip and unzip.  \end 

fun/2 Zip 
  Zip(x,y) = Foo

fun Unzip 
  Unzip(z) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    L(x) = L(y) -> L Zip(x,y) = L(x)
  \end
  \eq* 
    L(x) = L(y) & i < L(x) -> Sub(Zip(x,y),i) = Sub(x,i),Sub(y,i)
  \end

thm Zip_l
  L(x) = L(y) -> L Zip(x,y) = L(x)

thm Zip_sub
  L(x) = L(y) & i < L(x) -> Sub(Zip(x,y),i) = Sub(x,i),Sub(y,i)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    L(x) = L(y) -> Unzip Zip(x,y) = x,y
  \end

thm Unzip_zip
  L(x) = L(y) -> Unzip Zip(x,y) = x,y

rem 
  \para \bf  Interval.  \end 

fun/2 Interval 'Tex_f2_ln_interval'
  Interval(m,n) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    L Interval(m,n) = n+1-m
  \end
  \eq* 
    i < n+1-m -> Sub(Interval(m,n),i) = m+i
  \end

thm Interval_l
  L Interval(m,n) = n+1-m

thm Interval_sub
  i < n+1-m -> Sub(Interval(m,n),i) = m+i

rem 
  \para \bf  Take and drop.  \end 

fun/2 Take 
  Take(n,x) = Foo

fun/2 Drop 
  Drop(n,x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    n <= L(x) -> L Take(n,x) = n
  \end
  \eq* 
    n <= L(x) -> \e y x = Take(n,x)++y
  \end

thm Take_l
  n <= L(x) -> L Take(n,x) = n

thm Take_prefix
  n <= L(x) -> \e y x = Take(n,x)++y

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    n <= L(x) -> L Drop(n,x) = L(x)-n
  \end
  \eq* 
    n <= L(x) -> \e y x = y++Drop(n,x)
  \end

thm Drop_l
  n <= L(x) -> L Drop(n,x) = L(x)-n

thm Drop_suffix
  n <= L(x) -> \e y x = y++Drop(n,x)

rem 
  \para \bf  Minimum and maximum of lists.  \end 

fun Minl 
  Minl(x) = Foo

fun Maxl 
  Maxl(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x != 0 -> Minl(x) in x
  \end
  \eq* 
    x != 0 & a in x -> Minl(x) <= a
  \end

thm Minl_in
  x != 0 -> Minl(x) in x

thm Minl_min
  x != 0 & a in x -> Minl(x) <= a
proof  proved.

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x != 0 -> Maxl(x) in x
  \end
  \eq* 
    x != 0 & a in x -> a <= Maxl(x)
  \end

thm Maxl_in
  x != 0 -> Maxl(x) in x

thm Maxl_max
  x != 0 & a in x -> a <= Maxl(x)

rem 
  \para \bf  Deleting elements from lists.  \end 

fun/2 Delall 
  Delall(a,x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    b in Delall(a,x) <-> b in x & b != a
  \end

thm Delall_in
  b in Delall(a,x) <-> b in x & b != a

rem 
  \para \bf  Filter.  \end 

theory Theory_filter

pred A 

fun Filter 'Tex_f1_ln_filter_a'
  Filter(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    a in Filter(x) <-> a in x & A(a)
  \end

thm Filter_in
  a in Filter(x) <-> a in x & A(a)

end theory Theory_filter

